﻿using System;
using System.Collections.Generic;

public class SmartEvent<T> {

	private readonly LinkedList<T> _actions = new LinkedList<T>();

	public LinkedList<T> Actions { get { return _actions; } }

	public static SmartEvent<T> operator +(SmartEvent<T> smartEvent, T action) {
		smartEvent._actions.AddLast(action);
		return smartEvent;
	}

	public static SmartEvent<T> operator -(SmartEvent<T> smartEvent, T action) {
		smartEvent._actions.Remove(action);
		return smartEvent;
	}

}